package de.hsbo.fbv.bmg.graphics.transforms.buch;


import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Ellipse2D;

import javax.swing.JLabel;
import javax.swing.JSlider;

import de.hsbo.fbv.bmg.graphics.transforms.BilinearTransform;



public class BilinearDemoFrame extends JFrame {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JLabel jLabelTx = null;
	private JSlider jSliderTx = null;
	private JLabel jLabelTy = null;
	private JSlider jSliderTy = null;
	private JLabel jLabelM = null;
	private JSlider jSliderM = null;
	private JLabel jLabelR = null;
	private JSlider jSliderR = null;
	private JLabel jLabelSx = null;
	private JSlider jSliderSx = null;
	private JLabel jLabelSy = null;
	private JSlider jSliderSy = null;
	private JLabel jLabelBx = null;
	private JSlider jSliderBx = null;
	private JLabel jLabelBy = null;
	private JSlider jSliderBy = null;
	private JPanel jPanel = null;
	
	// Manuell eingefuegter Quelltext
	Shape[] shapes = shapesInitialize();
	BilinearTransform bt0 = null;
	BilinearTransform bt = null;
	double tx = 0, ty = 0, m = 1, r = 0, sx = 0, sy = 0, bx = 0, by =0;
		
	
	/**
	 * This is the default constructor
	 */
	public BilinearDemoFrame() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(800, 600);
		this.setContentPane(getJContentPane());
		this.setTitle("BilinearTransform Demo");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabelBy = new JLabel();
			jLabelBy.setBounds(new Rectangle(15, 406, 199, 16));
			jLabelBy.setText("Konvergenz y");
			jLabelBx = new JLabel();
			jLabelBx.setBounds(new Rectangle(15, 350, 199, 16));
			jLabelBx.setText("Konvergenz x");
			jLabelSy = new JLabel();
			jLabelSy.setBounds(new Rectangle(15, 294, 199, 16));
			jLabelSy.setText("Scherung y");
			jLabelSx = new JLabel();
			jLabelSx.setBounds(new Rectangle(15, 238, 199, 16));
			jLabelSx.setText("Scherung x");
			jLabelR = new JLabel();
			jLabelR.setBounds(new Rectangle(15, 182, 199, 16));
			jLabelR.setText("Drehung");
			jLabelM = new JLabel();
			jLabelM.setBounds(new Rectangle(15, 126, 199, 16));
			jLabelM.setText("Mastab");
			jLabelTy = new JLabel();
			jLabelTy.setBounds(new Rectangle(15, 70, 199, 16));
			jLabelTy.setText("Verschiebung y");
			jLabelTx = new JLabel();
			jLabelTx.setBounds(new Rectangle(15, 14, 199, 16));
			jLabelTx.setText("Verschiebung x");
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(jLabelTx, null);
			jContentPane.add(getJSliderTx(), null);
			jContentPane.add(jLabelTy, null);
			jContentPane.add(getJSliderTy(), null);
			jContentPane.add(jLabelM, null);
			jContentPane.add(getJSliderM(), null);
			jContentPane.add(jLabelR, null);
			jContentPane.add(getJSliderR(), null);
			jContentPane.add(jLabelSx, null);
			jContentPane.add(getJSliderSx(), null);
			jContentPane.add(jLabelSy, null);
			jContentPane.add(getJSliderSy(), null);
			jContentPane.add(jLabelBx, null);
			jContentPane.add(getJSliderBx(), null);
			jContentPane.add(jLabelBy, null);
			jContentPane.add(getJSliderBy(), null);
			jContentPane.add(getJPanel(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jSliderTx	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSliderTx() {
		if (jSliderTx == null) {
			jSliderTx = new JSlider();
			jSliderTx.setBounds(new Rectangle(15, 42, 199, 16));
			jSliderTx.setMinimum(0);
			jSliderTx.setMaximum(100);
			jSliderTx.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					int sv = jSliderTx.getValue();
					tx = (sv-50)*0.5;
					jLabelTx.setText("Verschiebung x: "+rnd5(tx));
				}
			});
			jSliderTx.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseReleased(java.awt.event.MouseEvent e) {
					bt.translate(tx, 0);
					repaint();
				}
			});
		}
		return jSliderTx;
	}

	/**
	 * This method initializes jSliderTy	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSliderTy() {
		if (jSliderTy == null) {
			jSliderTy = new JSlider();
			jSliderTy.setBounds(new Rectangle(15, 98, 199, 16));
			jSliderTy.setMinimum(0);
			jSliderTy.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					int sv = jSliderTy.getValue();
					ty = (sv-50)*0.5;
					jLabelTy.setText("Verschiebung y: "+rnd5(ty));
				}
			});
			jSliderTy.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseReleased(java.awt.event.MouseEvent e) {
					bt.translate(0, ty);
					repaint();
				}
			});
		}
		return jSliderTy;
	}

	/**
	 * This method initializes jSliderM	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSliderM() {
		if (jSliderM == null) {
			jSliderM = new JSlider();
			jSliderM.setBounds(new Rectangle(15, 154, 199, 16));
			jSliderM.setMinimum(0);
			jSliderM.setName("");
			jSliderM.setMaximum(100);
			jSliderM.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					int sv = jSliderM.getValue();
					m = sv*0.02;
					jLabelM.setText("Mastab: "+rnd5(m));
				}
			});
			jSliderM.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseReleased(java.awt.event.MouseEvent e) {
					bt.scale(m, m);
					repaint();
				}
			});
		}
		return jSliderM;
	}

	/**
	 * This method initializes jSliderR	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSliderR() {
		if (jSliderR == null) {
			jSliderR = new JSlider();
			jSliderR.setBounds(new Rectangle(15, 210, 199, 16));
			jSliderR.setMinimum(0);
			jSliderR.setMaximum(100);
			jSliderR.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					int sv = jSliderR.getValue();
					r = (sv-50);
					jLabelR.setText("Drehung: "+rnd5(r)+"");
				}
			});
			jSliderR.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseReleased(java.awt.event.MouseEvent e) {
					bt.rotate(Math.toRadians(r), 0, 0);
					repaint();
				}
			});
		}
		return jSliderR;
	}

	/**
	 * This method initializes jSliderSx	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSliderSx() {
		if (jSliderSx == null) {
			jSliderSx = new JSlider();
			jSliderSx.setBounds(new Rectangle(15, 266, 199, 16));
			jSliderSx.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					int sv = jSliderSx.getValue();
					sx = (sv-50)*1.e-2;
					jLabelSx.setText("Scherung x: "+rnd5(sx));
				}
			});
			jSliderSx.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseReleased(java.awt.event.MouseEvent e) {
					bt.shear(sx, 0);
					repaint();
				}
			});
		}
		return jSliderSx;
	}

	/**
	 * This method initializes jSliderSy	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSliderSy() {
		if (jSliderSy == null) {
			jSliderSy = new JSlider();
			jSliderSy.setBounds(new Rectangle(15, 322, 199, 16));
			jSliderSy.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					int sv = jSliderSy.getValue();
					sy = (sv-50)*1.e-2;
					jLabelSy.setText("Scherung y: "+rnd5(sy));
				}
			});
			jSliderSy.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseReleased(java.awt.event.MouseEvent e) {
					bt.shear(0, sy);
					repaint();
				}
			});
		}
		return jSliderSy;
	}

	/**
	 * This method initializes jSliderBx	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSliderBx() {
		if (jSliderBx == null) {
			jSliderBx = new JSlider();
			jSliderBx.setBounds(new Rectangle(15, 378, 199, 16));
			jSliderBx.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					int sv = jSliderBx.getValue();
					bx = (sv-50)*1.e-4;
					jLabelBx.setText("Konvergenz x: "+rnd5(bx));
				}
			});
			jSliderBx.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseReleased(java.awt.event.MouseEvent e) {
					bt.converge(bx, 0);
					repaint();
				}
			});
		}
		return jSliderBx;
	}

	/**
	 * This method initializes jSliderBy	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSliderBy() {
		if (jSliderBy == null) {
			jSliderBy = new JSlider();
			jSliderBy.setBounds(new Rectangle(15, 434, 199, 16));
			jSliderBy.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					int sv = jSliderBy.getValue();
					by = (sv-50)*1.e-4;
					jLabelBy.setText("Konvergenz y: "+rnd5(by));
				}
			});
			jSliderBy.addMouseListener(new java.awt.event.MouseAdapter() {
				public void mouseReleased(java.awt.event.MouseEvent e) {
					bt.converge(0, by);
					repaint();
				}
			});
		}
		return jSliderBy;
	}

	private Shape[] shapesInitialize() {
		int n = 5, k = 0;
		Shape[] shapes = new Shape[n*n];
		for(int i=0; i<n; i++)
			for(int j=0; j<n; j++) {
				shapes[k++] = new Ellipse2D.Double(50*(i-n/2.0),50*(j-n/2.0),50,50);
			}
		return shapes;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jPanel = new JPanel() {
				private static final long serialVersionUID = 1L;
				public void paint(Graphics g) {
					Graphics2D g2 = (Graphics2D)g;
					int wh = getWidth()/2;
					int hh = getHeight()/2;
					g2.scale(1, -1);
					g2.translate(wh, -hh);
					if(bt==null) 
						bt = new BilinearTransform();
					g2.setColor(new Color(255,0,0,128));
					for(int i=0; i<shapes.length; i++)
						g2.fill(shapes[i]);
					g2.setColor(new Color(0,0,255, 128));
					for(int i=0; i<shapes.length; i++)
						g2.fill(bt.transform(shapes[i]));
				}
			};
			jPanel.setLayout(null);
			jPanel.setBounds(new Rectangle(240, 2, 623, 562));
			
		}
		return jPanel;
	}
	
	private double rnd5(double v) {
		return Math.rint(v*1.e+5)/1.e+5;
	}
}