package de.hsbo.fbv.bmg.graphics.transforms.demos;

import java.awt.geom.Point2D;
import java.awt.geom.Point2D.Double;
import java.util.HashMap;
import java.util.Map;

import de.hsbo.fbv.bmg.graphics.transforms.BilinearTransform;
import de.hsbo.fbv.bmg.graphics.transforms.TransformFactory;



/**
 * Testklasse, die die Berechnung der inversen Parameter eine bilinearen Transformation durchfhrt.
 * Mit diesem Beispiel lsst sich zeigen, dass die Umkehrabbildung einer bilinearen Transformation 
 * nicht fr alle Koordinaten durch eine einheitliche Transformationsmatrix angegeben werden kann, 
 * und daher als Lsungsansatz ausscheidet.  
 * @author zimmermann
 *
 */
public class InverseBilinearTransformTest1 {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// Ausgangstransformation festlegen
		BilinearTransform bt = new BilinearTransform();
		bt.translate(Math.random()*1000, Math.random()*1000);
		bt.scale(Math.random(), Math.random());
		double alpha = Math.random()*Math.PI;
		bt.rotate(alpha, alpha);
		bt.converge(Math.random()*0.02, Math.random()*0.02);
		
		// Zufallspunkte berechnen und Differenzen feststellen
		for(int i=0; i<10; i++) {
			Point2D op = new Point2D.Double(Math.floor(Math.random()*1000000)/1000, 
					Math.floor(Math.random()*1000000)/1000);
			Point2D tp = bt.inverseTransform(bt.transform(op));
			System.out.println(op+"\t "+tp+"\t "+op.distance(tp));
			System.out.println();
		}
		
	}

}
