package de.hsbo.fbv.bmg.graphics.transforms.demos;


import java.awt.Shape;
import java.awt.geom.Line2D;
import java.awt.geom.Path2D.Double;

import de.hsbo.fbv.bmg.graphics.transforms.Point2hD;
import de.hsbo.fbv.bmg.graphics.transforms.Shape2hD;
import de.hsbo.fbv.bmg.graphics.transforms.Transform2hD;



public class SimpleLine2hD implements Shape2hD {
	
	Point2hD s = null;
	Point2hD e = null;
	
	public SimpleLine2hD(Point2hD s, Point2hD e) {
		this.s = s;
		this.e = e;
	}
	
	@Override
	public Shape toShape() {
		if(s==null || e==null)
			return null;
		else
		return new Line2D.Double(
				s.toPoint2D().getX(), s.toPoint2D().getY(),
				e.toPoint2D().getX(), e.toPoint2D().getY());
	}

	@Override
	public Shape2hD toShape2hD(Transform2hD transform) {
		if(transform == null)
			return this;
		else 
			return new SimpleLine2hD(s.toPoint2hD(transform), 
				e.toPoint2hD(transform));
	}

}
