package de.hsbo.fbv.bmg.graphics.viewer.aufgaben;

import javax.swing.SwingUtilities;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JFrame;

/**
 * TestFrame demonstriert die Verwendung und testet die Funktionalitt von SimpleShapeViewer.
 * Die Klasse kann als Application und als Java-Bean aufgerufen werden.
 * Das SimpleShapeViewer-Objekt ist als Attribut jContentPane eingebunden.
 * @author A.Zimmermann, HS Bochum, 2012
 *
 */
public class TestFrame extends JFrame {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				TestFrame thisClass = new TestFrame();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public TestFrame() {
		super();
		
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			// jContentPane = new JPanel();
			SimpleShapeViewer ssv = new SimpleShapeViewer();
			ssv.shapes = ShapeFactory.createShapes();
			jContentPane = ssv;
			
			jContentPane.setLayout(new BorderLayout());
		}
		return jContentPane;
	}

}
