package de.hsbo.fbv.bmg.graphics.viewer.commands;

import javax.swing.JFrame;

/**
 * Demo fr einen konfigurierbaren Viewer, der das Entwurfsmuster COMMAND implementiert.
 * Demo2 bietet weitere Interaktionen:<br>
 * - MouseEntered stellt den Cursor auf CROSSHAIR (Fadenkreuz) um.<br>
 * - MouseExited setzt den Cursor auf den Standard zurck und gibt in der Titelleiste "Cursor lost!" an.<br>
 * - MouseMoved gibt in der Titelleiste die Mauskoordinaten im WCS an.<br>
 * - MouseDragged verschiebt die Graphik im Fenster.<br>
 * @author A.Zimmermann, HS Bochum, 2011
 * @see Gamma,et.al.: Entwurfsmuster, Addison-Wesley, 1996
 *
 */
public class Demo2 extends JFrame {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Demo2 mapFrame = new Demo2();
		mapFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		mapFrame.setVisible(true);
	}

	private static final long serialVersionUID = 1L;
	Map map = null;

	/**
	 * This is the default constructor
	 */
	public Demo2() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(420, 340);
		this.map = new MapAdapter();
		this.map.setFrame(this);
		this.map.initialize(new Demo2MapCmdInitialize(this.map));
		// this.map.initialize(new ViewMapCmdInitialize(this.map));
		this.setContentPane(map.getPanel());
		this.setTitle("MapFrame");
	}


}
