package de.hsbo.fbv.bmg.graphics.viewer.commands;

import java.awt.geom.Rectangle2D;

/**
 * Dieser Befehl dient zur Konfiguration des Map-Objektes fr Demo2.
 * @author A.Zimmermann, HS Bochum, 2011
 *
 */
public class Demo2MapCmdInitialize implements Command {
	
	// Attribut
	Map map = null;

	// Konstruktor
	public Demo2MapCmdInitialize(Map map) {
		this.map = map;
	}
	
	@Override
	public void execute() {
		this.map.setWorldBounds(new Rectangle2D.Double(0,0,400,300));
		// CmdPaint 			=  0;
		// this.map.setCommand(Map.CmdPaint, new MapCmdTransformedPaint(this.map));
		this.map.setCommand(Map.CmdPaint, new Demo2MapCmdPaint(this.map));
		// CmdMouseReleased		=  1;
		// CmdMousePressed 		=  2;
		// CmdMouseExited		=  3;
		this.map.setCommand(Map.CmdMouseExited, new MapCmdMouseExited(this.map));		
		// CmdMouseEntered 		=  4;
		this.map.setCommand(Map.CmdMouseEntered, new MapCmdMouseEntered(this.map));		
		// CmdMouseClicked		=  5;
		// CmdMouseMoved 		=  6;
		this.map.setCommand(Map.CmdMouseMoved, new MapCmdMouseMoved(this.map));				
		// CmdMouseDragged		=  7;
		this.map.setCommand(Map.CmdMouseDragged, new MapCmdMouseDragged(this.map));		
		// CmdMouseWheelMoved	=  8;
		this.map.setCommand(Map.CmdMouseWheelMoved, new MapCmdWheelMoved(this.map));		
		// CmdKeyTyped 			=  9;
		// CmdKeyReleased		= 10;
		// CmdKeyPressed 		= 11;
	}
}
