package de.hsbo.fbv.bmg.graphics.viewer.demos;


import java.awt.Color;
import java.awt.Shape;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Path2D;
import java.awt.geom.Rectangle2D;

import de.hsbo.fbv.bmg.graphics.viewer.simple.ShapeLayer;
import de.hsbo.fbv.bmg.graphics.viewer.simple.SimpleMapFrame;


public class SimpleMapFrameDemo {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// Ein Objekt vom Typ SimpleShapeFrame instanziieren
		SimpleMapFrame frame = new SimpleMapFrame();
		
		// Neuen Layer generieren
		ShapeLayer<Shape> layer = new ShapeLayer<Shape>();
		
		// Linienfarbe (weiss) setzen
		layer.setDrawColor(Color.WHITE);
		
		// Fllfarbe (pink) setzen
		layer.setFillColor(new Color(255,128,128));
		
		// Graphiken vom Typ java.awt.Shape bergeben.
		layer.add(new Rectangle2D.Double(1000,1000,1000,1000));
		layer.add(new Rectangle2D.Double(500,500,1000,1000));
		layer.add(new Ellipse2D.Double(1100, 1800, 800, 1000));
		
		// ein Trapez konstruieren und an den Layer bergeben
		Path2D trapez = new Path2D.Double();
		trapez.moveTo( 800,  800);
		trapez.lineTo(2200,  800);
		trapez.lineTo(2000, 1000);
		trapez.lineTo(1000, 1000);
		trapez.lineTo( 800,  800);	
		// trapez.closePath();
		layer.add(trapez);	
		
		// Layer an das Anwnedungsfenster bergeben
		frame.getMap().add(layer);
		
		// Fenster am Desktop anzeigen lassen
		frame.setVisible(true);
	}

}
